judpAppDirectives.directive('srvUrl', function() {
    return {
        restrict: 'A',
        replace: false,
        scope: true,
        compile: function(tElem, tAttrs){
        //    var pullRefresh = (tAttrs.pullRefresh == undefined || tAttrs.pullRefresh === "true") ? true : false;
            var pageLoad = (tAttrs.pageLoad == undefined || tAttrs.pageLoad === "true") ? true : false;

/*            if (pullRefresh){
                var strPullRefresh = '<ion-refresher  pulling-text="下拉刷新..." on-refresh="loadData()"></ion-refresher>';
                tElem.append(strPullRefresh);
            }*/
            if (pageLoad){
                var strLoadmore = '<ion-infinite-scroll  on-infinite="loadMore()"  spinner="dots" distance="20%" ng-if="more"></ion-infinite-scroll>';
                tElem.append(strLoadmore);
            }
        },
        controller: function ($scope, $element, $attrs, $timeout, Util, $ionicScrollDelegate) {
            $scope.setParams = function(){
                $scope.srvUrl = $scope.options.srvUrl;
                $scope.pageSize = $scope.options.pageSize || 15;
                $scope.pageLoad = $scope.options.pageLoad == undefined ? true : false;
                $scope.params = $scope.options.params || {} ;
                $scope.scrollHandler = $attrs.delegateHandle;

                var pageParam = {
                    rows: $scope.pageSize,
                    page: $scope.curPage
                };
                if (!$scope.pageLoad){
                    pageParam = {
                        rows: 1000,
                        page: 1
                    };
                }
                $scope.params = angular.extend($scope.params, pageParam);
            };

            $scope.loadData = function(){
                $scope.dataList = [];
                $scope.more = false;
                $scope.curPage = 1;
                $scope.param.dataloading = true;
                $scope.setParams();

                Util.ajax.get($scope.srvUrl, $scope.params).then(function(data){
                    if ($scope.pageLoad){
                        if (angular.isArray(data.rows) && data.rows.length > 0){
                            $scope.dataList = data.rows;
                            $scope.curPage++;
                            $scope.more = data.page < data.total;
                        }else
                            $scope.more = false;
                    }else{
                        if (angular.isArray(data.rows) && data.rows.length > 0)
                            $scope.dataList = data.rows;
                    }

                    if (typeof($scope.afterLoadData) ==  "function")
                        $scope.afterLoadData(data);
                }).finally(function(){
                    if ($scope.scrollHandler){
                        $timeout(function(){
                            $ionicScrollDelegate.$getByHandle($scope.scrollHandler).scrollTop();
                        }, 300);
                    }
                    $scope.param.dataloading = false;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            };

            $scope.loadMore = function(){
                var params = {};
                $scope.param.dataloading = true;
                angular.copy($scope.params, params);
                params.page = $scope.curPage;
                Util.ajax.get($scope.srvUrl, params).then(
                    function(data){
                        if (angular.isArray(data.rows) && data.rows.length > 0){
                            $scope.dataList = $scope.dataList.concat(data.rows);
                            $scope.curPage++;
                            $scope.more = data.page < data.total;
                        }else {
                            $scope.more = false;
                        }
/*                        if (!$scope.more) {
                            $timeout(function () {
                                Util.common.toast("没有更多的数据要加载了");
                            }, 1000);
                        }*/
                        if (typeof($scope.afterLoadMore) ==  "function")
                            $scope.afterLoadMore(data);
                    },
                    function(){
                        $scope.more = false;
                    }
                ).finally(function(){
                    $scope.param.dataloading = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                });
            };
        }
    };
})
.directive('ngEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if (event.which === 13) {
                scope.$apply(function () {
                    scope.$eval(attrs.ngEnter);
                });

                event.preventDefault();
            }
        });
    };
});
