judpAppCrl.controller('LoginCtrl', function ($scope, $state, APP_CONSTANTS,
                                             $ionicLoading, $ionicViewSwitcher, Util, $ionicPlatform, LoginSrv, UserInfo) {

    function checkFieldsValid() {
        var valid = true;
        if (!$scope.data.username) {
            Util.common.toast("账号不能为空");
            valid = false;
        } else if (!$scope.data.password) {
            Util.common.toast("密码不能为空");
            valid = false;
        }
        localStorage.setItem("rememberMe", $scope.data.rememberMe);
        if ($scope.data.rememberMe) {
            localStorage.setItem("username", $scope.data.username);
            localStorage.setItem("password", $scope.data.password);
        } else {
            localStorage.setItem("username", "");
            localStorage.setItem("password", "");
        }
        return valid;
    }

    $scope.data = {
        username: localStorage.username || "",
        password: localStorage.password || "",
        rememberMe: localStorage.rememberMe == "true" ? true : false,
        userid: localStorage.userId
    };


    $scope.login = function (callback) {
        if (checkFieldsValid()) {
            $ionicLoading.show({
                template: "正在登陆中"
            });

            Util.ajax.get("/api/login", {account: $scope.data.username, password: $scope.data.password}).then(
                function (result) {
                    if (result.success) {
                        Util.jpush.setAlias($scope.data.username);
                        $state.go(APP_CONSTANTS.HOME_PAGE);
                        UserInfo.userName = $scope.data.username;
                    }
                    else
                        Util.common.toast(result.message);
                },
                function (err) {
                    console.log(JSON.stringify(err));
                    Util.common.toast("登录失败！系统服务暂不可用！");
                }
            );
        }
    };

    $scope.resetPassword = function () {
        $state.go("resetPwd");
    };

    var hideVersion = function () {
        document.querySelector("#versions").classList.add("keyboard-open");
    };
    var showVersion = function () {
        document.querySelector("#versions").classList.remove("keyboard-open");
    };
    window.addEventListener('native.keyboardshow', hideVersion);
    window.addEventListener('native.keyboardhide', showVersion);

    var wdq = $scope.$watch("data.query", function (value) {
        APP_CONSTANTS.SERVER = value;
    });

    $scope.$on("$destroy", function () {
        window.removeEventListener("native.keyboardshow", hideVersion);
        window.removeEventListener("native.keyboardhide", showVersion);
        wdq();
    });

    $scope.data.query = APP_CONSTANTS.SERVER;
    $scope.data.version = APP_CONSTANTS.Version;

    $scope.redirectToUpdateLink = function () {
        var url = ionic.Platform.isAndroid() ? "http://www.pgyer.com/" +  APP_CONSTANTS.DEPLOYINFO.ANDROID_SHORTCUT: "http://www.pgyer.com/" + APP_CONSTANTS.DEPLOYINFO.IOS_SHORTCUT;
        window.open(url, "_system", "location=yes");
    };


});
