judpAppCrl.controller('HomeCtrl', function ($scope, $state) {
    $scope.param = {
        hideTab: false,
        selectbook: null,
        default_book_img: 'img/home/book.jpg',
        masking: false,
        searchStr: "",
        reloadTab: [],
        dataloading: false
    };

    $scope.share = {selectQry: "CLASS", noresult: false};
    $scope.mybook = {selectQry: "UP", noresult: false};
    $scope.borrow = {selectQry: "ALL", noresult: false};
    $scope.lend = {selectQry: "ALL", noresult: false};

    if (!localStorage.firstMasking) {
        $scope.param.masking = true;
    }

    $scope.iKnowClick = function () {
        $scope.param.masking = false;
        localStorage.firstMasking = true;
    };

    $scope.goPage = function (page) {
        $state.go(page);
    };

})
/* 我的书架*/
.controller('BookShelfCtrl',
    function ($scope, $state, $cordovaBarcodeScanner, ShelfSrv, Util, $cordovaStatusbar) {
        $scope.isScaning = false;
        $scope.activeIndex = 0;

        if (window.StatusBar) {
            $cordovaStatusbar.styleHex('#05c1ab');
            $cordovaStatusbar.show();
        }

        $scope.goBookDetail = function (item) {
            $scope.param.selectbook = item;
            $scope.param.selectbook.canUp = $scope.activeIndex == 1;
            $scope.param.selectbook.canDown = $scope.activeIndex == 1;
            $state.go("home.bookdetail");
        };

        $scope.$on("$ionicSlides.slideChangeStart", function(event, data){
            $scope.activeIndex = data.slider.activeIndex;
        });

        $scope.$on('$ionicView.beforeEnter', function () {
            if ($scope.param.reloadTab.length > 0) {
                $scope.$broadcast("mybook_reload_event", $scope.param.reloadTab);
            }
        });

        $scope.search = function () {
            $scope.$broadcast("searchbook_event", $scope.param.searchStr);
        };

        $scope.addBook = function () {
            if ($scope.isScaning)
                return;

            $scope.isScaning = true;
            Util.common.barcodeScan().then(function (isbn) {
                    Util.common.toast(isbn);
                    ShelfSrv.queryBook(isbn).then(
                        function (data) {
                            if (Util.common.isSuccess(data)) {
                                $scope.param.selectbook = data.data;
                                $scope.param.selectbook.canUp = true;
                                $scope.param.selectbook.canDown = true;
                                $state.go("home.bookdetail");
                            } else {
                                Util.common.toast("未查询到书籍信息！");
                            }
                        },
                        function (err) {
                            Util.common.warn(err);
                        }
                    );
                },
                function (err) {
                    Util.common.err("条码扫描失败！" + JSON.stringify(err));
                }).finally(function () {
                    $scope.isScaning = false;
            });
        };
    })
/* 班级共享*/
.controller('ShareBookListCtrl', function ($scope, ShelfSrv) {
    $scope.options = {
        srvUrl: ShelfSrv.SRV_URL.CLASS_BOOK_LIST
    };

    $scope.$watch("activeIndex", function(){
        if ($scope.activeIndex == 0){
            if (!$scope.dataList || $scope.dataList.length == 0)
                $scope.loadData();
        }
    });

    $scope.$watch("share.selectQry", function (val) {
        if (val == 'CLASS')
            $scope.options.srvUrl = ShelfSrv.SRV_URL.CLASS_BOOK_LIST;
        else if (val == 'GRADE')
            $scope.options.srvUrl = ShelfSrv.SRV_URL.GRADE_BOOK_LIST;
        else if (val == 'SCHOOL')
            $scope.options.srvUrl = ShelfSrv.SRV_URL.SCHOOL_BOOK_LIST;
        else
            $scope.options.srvUrl = ShelfSrv.SRV_URL.CLASS_BOOK_LIST;
        $scope.loadData();
    });

    $scope.$on("searchbook_event", function (e, searchStr) {
        $scope.options.params = {where: {title: searchStr}};
        $scope.loadData();
    });

    $scope.$on("mybook_reload_event", function (event, reloadTab) {
        if (angular.isArray(reloadTab) && reloadTab.indexOf(1) != -1){
            $scope.loadData();
        }
    });

    $scope.afterLoadData = function () {
        $scope.share.noresult = $scope.dataList.length == 0;
    };
})
/* 我的书籍*/
.controller('MybookListCtrl', function ($scope, ShelfSrv) {
    $scope.options = {
        srvUrl: ShelfSrv.SRV_URL.MY_BOOK_LIST + "?mytype=on"
    };

    $scope.$watch("activeIndex", function(){
        if ($scope.activeIndex == 1){
            if (!$scope.dataList || $scope.dataList.length == 0)
                $scope.loadData();
        }
    });

    $scope.$watch("mybook.selectQry", function (val) {
        if ($scope.activeIndex == 1) {
            if (val == 'UP')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BOOK_LIST + "?mytype=on";
            else if (val == 'DOWN')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BOOK_LIST + "?mytype=off";
            else if (val == 'DONATE')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BOOK_LIST + "?mytype=donate";
            else
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BOOK_LIST + "?mytype=on";
            $scope.loadData();
        }
    });

    $scope.$on("searchbook_event", function (e, searchStr) {
        $scope.options.params = {where: {title: searchStr}};
        $scope.loadData();
    });

    $scope.$on("mybook_reload_event", function (event, reloadTab) {
        if (angular.isArray(reloadTab) && reloadTab.indexOf(2) != -1){
            $scope.loadData();
        }
    });

    $scope.afterLoadData = function () {
        $scope.mybook.noresult = $scope.dataList.length == 0;
    }
})
.controller('InListCtrl', function ($scope, ShelfSrv, Util, $state) {
    $scope.options = {
        srvUrl: ShelfSrv.SRV_URL.MY_BORROW + "/all"
    };

    $scope.$watch("activeIndex", function(){
        if ($scope.activeIndex == 2){
            if (!$scope.dataList || $scope.dataList.length == 0)
                $scope.loadData();
        }
    });

    $scope.$on("searchbook_event", function (e, searchStr) {
        $scope.options.params = {where: {title: searchStr}};
        $scope.loadData();
    });

    $scope.$on("mybook_reload_event", function (event, reloadTab) {
        if (angular.isArray(reloadTab) && reloadTab.indexOf(3) != -1){
            $scope.loadData();
        }
    });

    $scope.$watch("borrow.selectQry", function (val) {
        if ($scope.activeIndex == 2) {
            if (val == 'ALL')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BORROW + "/all";
            else if (val == 'REQEUST')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BORROW + "/apply";
            else if (val == 'BORROWING')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BORROW + "/baback";
            else
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_BORROW + "/finish";
            $scope.loadData();
        }
    });

    $scope.afterLoadData = function () {
        $scope.borrow.noresult = $scope.dataList.length == 0;
    };

    <!--借书状态0:申请阶段，1:同意借出，2:准备交接，3:已借出，4:准备归还交接，7:取消借阅(申请人),8:不同意借阅，9:完成借阅-->
    $scope.cancelBorrow = function ($event, item) {
        $event.stopPropagation();
        var borrowInfo = {};
        borrowInfo.borrowid = item.borrowid;
        borrowInfo.owner = item.owner;
        borrowInfo.borrowstatus = 7;

        Util.common.confirm("您确定要取消借书申请？", function (result) {
            if (result == 1) {
                ShelfSrv.updateBorrow(borrowInfo).then(
                    function (data) {
                        if (data.success) {
                            item.borrowstatus = borrowInfo.borrowstatus;
                            Util.common.toast("取消申请成功！");
                        }
                        else
                            Util.common.toast("取消申请失败！");
                    },
                    function (err) {
                        Util.common.error(err);
                        Util.common.toast("取消申请失败！");
                    }
                );
            }
        });
    };

    $scope.borrowOk = function ($event, item) {
        $event.stopPropagation();

        var borrowInfo = {};
        borrowInfo.borrowid = item.borrowid;
        borrowInfo.owner = item.owner;
        borrowInfo.borrowstatus = 3;

        Util.common.confirm("您确定已收到书？", function (result) {
            if (result == 1) {
                ShelfSrv.updateBorrow(borrowInfo).then(
                    function (data) {
                        if (data.success) {
                            item.borrowstatus = borrowInfo.borrowstatus;
                            Util.common.toast("书籍借阅成功，请记得按时归还！");
                        }
                        else
                            Util.common.toast("状态修改失败！");
                    },
                    function (err) {
                        Util.common.error(err);
                        Util.common.toast("状态修改失败！");
                    }
                );
            }
        });
    };

    $scope.requestReturn = function ($event, item) {
        $event.stopPropagation();
        var borrowInfo = {};
        borrowInfo.borrowid = item.borrowid;
        borrowInfo.owner = item.owner;
        borrowInfo.borrowstatus = 4;
        Util.common.confirm("您确定申请归还书籍？", function (result) {
            if (result == 1) {
                ShelfSrv.updateBorrow(borrowInfo).then(
                    function (data) {
                        if (data.success) {
                            item.borrowstatus = borrowInfo.borrowstatus;
                            Util.common.toast("申请归还成功！");
                        }
                        else
                            Util.common.toast("申请归还失败！");
                    },
                    function (err) {
                        Util.common.error(err);
                        Util.common.toast("申请归还失败！");
                    }
                );
            }
        });
    };

    $scope.goBorrowDetail = function (item, type) {
        $state.go("home.borrowdetail", {bookItem: item, type: type});
    };

})
.controller('OutListCtrl', function ($scope, ShelfSrv, Util, $state) {
    $scope.options = {
        srvUrl: ShelfSrv.SRV_URL.MY_LEND + "/all"
    };

    $scope.$watch("activeIndex", function(){
        if ($scope.activeIndex == 3){
            if (!$scope.dataList ||  $scope.dataList.length == 0)
                $scope.loadData();
        }
    });

    $scope.$on("searchbook_event", function (e, searchStr) {
        $scope.options.params = {where: {title: searchStr}};
        $scope.loadData();
    });

    $scope.$on("mybook_reload_event", function (event, reloadTab) {
        if (angular.isArray(reloadTab) && reloadTab.indexOf(4) != -1){
            $scope.loadData();
        }
    });

    $scope.$watch("lend.selectQry", function (val) {
        if ($scope.activeIndex == 3) {
            if (val == 'ALL')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_LEND + "/all";
            else if (val == 'REQEUST')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_LEND + "/apply";
            else if (val == 'LENDING')
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_LEND + "/baback";
            else
                $scope.options.srvUrl = ShelfSrv.SRV_URL.MY_LEND + "/finish";
            $scope.loadData();
        }
    });

    $scope.goBorrowDetail = function (item, type) {
        $state.go("home.borrowdetail", {bookItem: item, type: type});
    };

    $scope.afterLoadData = function () {
        $scope.lend.noresult = $scope.dataList.length == 0;
    };


    $scope.agreeLend = function ($event, item) {
        $event.stopPropagation();
        var borrowInfo = {};
        borrowInfo.borrowid = item.borrowid;
        borrowInfo.owner = item.owner;
        borrowInfo.borrowstatus = 3;

        Util.common.confirm("您确定同意借阅？", function (result) {
            if (result == 1) {
                ShelfSrv.updateBorrow(borrowInfo).then(
                    function (data) {
                        if (data.success) {
                            item.borrowstatus = borrowInfo.borrowstatus;
                            Util.common.toast("已同意借阅！");
                        }
                        else
                            Util.common.toast("同意借阅失败！");
                    },
                    function (err) {
                        Util.common.error(err);
                        Util.common.toast("同意借阅失败！");
                    }
                );
            }
        });
    };

    $scope.refuseLend = function ($event, item) {
        $event.stopPropagation();
        var borrowInfo = {};
        borrowInfo.borrowid = item.borrowid;
        borrowInfo.owner = item.owner;
        borrowInfo.borrowstatus = 8;

        Util.common.confirm("您确定要拒绝借阅？", function (result) {
            if (result == 1) {
                ShelfSrv.updateBorrow(borrowInfo).then(
                    function (data) {
                        if (data.success) {
                            item.borrowstatus = borrowInfo.borrowstatus;
                            Util.common.toast("已拒绝借阅！");
                        }
                        else
                            Util.common.toast("拒绝借阅失败！");
                    },
                    function (err) {
                        Util.common.error(err);
                        Util.common.toast("拒绝借阅失败！");
                    }
                );
            }
        });
    };

    $scope.finishLend = function ($event, item) {
        $event.stopPropagation();
        var borrowInfo = {};
        borrowInfo.borrowid = item.borrowid;
        borrowInfo.owner = item.owner;
        borrowInfo.borrowstatus = 9;

        Util.common.confirm("您确定已完成借阅？", function (result) {
            if (result == 1) {
                ShelfSrv.updateBorrow(borrowInfo).then(
                    function (data) {
                        if (data.success) {
                            item.borrowstatus = borrowInfo.borrowstatus;
                            Util.common.toast("已完成借阅！");
                        }
                        else
                            Util.common.toast("完成借阅失败！");
                    },
                    function (err) {
                        Util.common.error(err);
                        Util.common.toast("完成借阅失败！");
                    }
                );
            }
        });
    };
})
/* 书籍详情*/
.controller('MybookDetailCtrl', function ($scope, Util, $ionicModal, ShelfSrv) {

    $scope.addBook = function () {
        if ($scope.isScaning)
            return;

        $scope.isScaning = true;
        Util.common.barcodeScan().then(function (isbn) {
                Util.common.toast(isbn);
                ShelfSrv.queryBook(isbn).then(
                    function (data) {
                        if (Util.common.isSuccess(data)) {
                            $scope.param.selectbook = data.data;
                            $scope.param.selectbook.canUp = true;
                            $scope.param.selectbook.canDown = true;
                            $scope.reloadData();
                        } else {
                            Util.common.toast("未查询到书籍信息！");
                        }
                    },
                    function (err) {
                        Util.common.warn(err);
                    }
                );
            },
            function (err) {
                Util.common.err("条码扫描失败！" + JSON.stringify(err));
            }).finally(function () {
            $scope.isScaning = false;
        });
    };

    $scope.queryClassowner = function () {
        ShelfSrv.queryClassowner($scope.isbn).then(
            function (data) {
                if (Util.common.isSuccess(data)) {
                    $scope.bookinfo.ownerList = data.data;
                }
            },
            function (err) {
                Util.common.error(err);
            }
        );
    };

    $scope.reloadData = function(){
        $scope.param.reloadTab = [];
        $scope.bookinfo = $scope.param.selectbook;
        $scope.isbn = $scope.bookinfo.isbnshort || $scope.bookinfo.isbnlong;
        $scope.bookinfo.showdonate = false;

        $scope.queryClassowner();
        ShelfSrv.queryIsOwner($scope.isbn).then(
            function (data) {
                $scope.bookinfo.ownership = data.data.ownership;
                $scope.bookinfo.oldOwnership = $scope.bookinfo.ownership;
                $scope.bookinfo.showdonate = $scope.bookinfo.bookstatus == 0 && $scope.bookinfo.donatestatus != 1;
            },
            function (err) {
                Util.common.error(err);
            }
        );
    };

    $scope.$on('$ionicView.beforeEnter', function () {
        //$scope.param.hideTab = true;
        $scope.reloadData();
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        $scope.param.hideTab = false;
    });

    $scope.bookOnOrDown = function () {
        var isbn = $scope.bookinfo.isbnshort || $scope.bookinfo.isbnlong;
        var state = $scope.bookinfo.ownership != 1 ? 1 : 0;
        var tip = $scope.bookinfo.ownership != 1 ? "上架" : "下架";

        var msg = Util.common.stringFormat("您确定要{0}此书吗？", tip);
        Util.common.confirm(msg, function (result) {
            if (result == 1) {
                ShelfSrv.onOffBook(isbn, state).then(
                    function (data) {
                        if (angular.isObject(data) && data.success) {
                            $scope.bookinfo.ownership = state;
                            $scope.bookinfo.bookstatus = state;
                            $scope.param.reloadTab = [1, 2];
                        }
                        Util.common.toast(data.message);
                    },
                    function (err) {
                        Util.common.toast(data.message);
                        Util.common.error(err);
                    }
                );
            }
        });
    };

    $scope.$watch("bookinfo.ownership", function () {
        $scope.bookinfo.showdonate = $scope.bookinfo.bookstatus == 0 && $scope.bookinfo.donatestatus != 1;
        if ($scope.bookinfo.ownership == 1) {
            $scope.opbtntitle = "下架此书";
        } else {
            $scope.opbtntitle = "上架此书";
        }
    }, true);

    $scope.donateBook = function () {
        var msg = "您确认要捐赠此书吗？";
        Util.common.confirm(msg, function (result) {
                if (result == 1) {
                    var isbn = $scope.bookinfo.isbnshort || $scope.bookinfo.isbnlong;
                    ShelfSrv.donateBook(isbn).then(function (result) {
                        if (result.success) {
                            $scope.param.reloadTab = [1, 2];
                            $scope.bookinfo.donatestatus = 1;
                            Util.common.toast("书籍捐赠成功！");
                        } else
                            Util.common.toast("书籍捐赠失败！");
                    }, function () {
                        Util.common.toast("书籍捐赠失败！");
                    });
                }
            }
        );
    };
    <!--借书状态0:申请阶段，1:同意借出，2:准备交接，3:已借出，4:准备归还交接，7:取消借阅(申请人),8:不同意借阅，9:完成借阅-->

    $scope.requestBrrowBook = function (item) {
        var borrowInfo = {};
        borrowInfo.isbn = item.isbn;
        borrowInfo.owner = item.owner;
        borrowInfo.borrowstatus = 0;

        Util.common.confirm("您确定要借阅此书吗？", function (result) {
            if (result == 1) {
                ShelfSrv.saveBorrow(borrowInfo).then(
                    function (data) {
                        if (data.success) {
                            $scope.param.reloadTab = [3];
                            Util.common.toast("申请借阅成功！");
                        }
                        else
                            Util.common.toast(data.message);
                    },
                    function (err) {
                        Util.common.error(err);
                        Util.common.toast("申请借阅失败！");
                    }
                ).finally(function () {
                    $scope.queryClassowner();
                })
            }
        });
    };

})

/* 借阅状态历史*/
.controller('BorrowDetailCtrl', function ($scope, ShelfSrv, $stateParams) {
    $scope.item = $stateParams.bookItem;
    $scope.type = $stateParams.type;

    $scope.statusList = [];
    ShelfSrv.queryBrrowStachange($scope.item.borrowid).then(
        function (data) {
            if (data && data.success)
                $scope.statusList = data.data;
            else
                $scope.statusList = [];
        },
        function () {
            $scope.statusList = [];
        }
    )
});
