judpAppServ.factory('ShelfSrv', function (Util) {
    return {
        SRV_URL: {
            MY_LEND: "/borrow/mylend",  /*我的借出*/
            MY_BORROW: "/borrow/myborrow",  /*我的借阅*/
            CLASS_BOOK_LIST: "/booksLibrary/findMyClassBookList",  /*我的班级共享图书*/
            GRADE_BOOK_LIST: "/booksLibrary/findMyGradeBookList",  /*我的年级共享图书*/
            SCHOOL_BOOK_LIST: "/booksLibrary/findMySchoolBookList",  /*我的学校共享图书*/
            MY_BOOK_LIST: "/booksLibrary/findMyBookList"   /*我的书籍*/
        },
        queryBook: function(isbn){
            return Util.ajax.get("/booksLibrary/queryBook/" + isbn);
        },
        queryIsOwner: function(isbn){
            return Util.ajax.get("/booksShelf/isowner/" + isbn);
        },
        queryClassowner: function(isbn){
            return Util.ajax.get("/booksLibrary/classowner/" + isbn);
        },
        onOffBook: function(isbn, state){
            return Util.ajax.get("/booksShelf/onoff/" + isbn + "/" + state);
        },
        saveBorrow: function (item) {
            // return Util.ajax.post("/borrow/save", item);
            var url = Util.common.stringFormat("/borrow/save?ssb_borrow.owner={0}&ssb_borrow.isbn={1}&ssb_borrow.borrowstatus={2}",
                item.owner, item.isbn, item.borrowstatus);
            return Util.ajax.post(url);
        },
        updateBorrow: function (item) {
            var url = Util.common.stringFormat("/borrow/update?ssb_borrow.borrowid={0}&ssb_borrow.borrowstatus={1}",
                item.borrowid, item.borrowstatus);
            return Util.ajax.post(url);
        },
        queryBrrowStachange: function(borrowid){
            return Util.ajax.post("/borrowStachange/changelist/" + borrowid);
        },
        donateBook: function(isbn){
            return Util.ajax.post("/booksShelf/donate/" + isbn);
        }
    }
});