judpAppCrl.controller('UserProfileCtrl', function ($scope, $state, UserInfo) {
    $scope.userpic = UserInfo.userPic;
    $scope.username = UserInfo.userName;

    $scope.logout = function () {
        $state.go("login");
    };
    $scope.goUserScholl = function () {
        $state.go("home.userschool");
    };
}).controller('UserDetailCtrl', function ($scope) {
    $scope.weixinCharge = function () {
        var total = Math.round(0.01 * 100);
        $http({
            method: 'get',
            url: "http://wy.star-riverliquor.com:9836/srp/rest/getWxPayCongig?total=" + total,
            timeout: 300000
        }).then(function (result) {
            if (result.sucess) {
                //{"data":{"appid":"wx06fd51571bcac40c","noncestr":"564645fbd0332f066cbd9d083ddd077c","package":"Sign=WXPay","partnerid":"1332072101","prepayid":"wx2016081710583754d46414850301222415","sign":"CE85EF9D889F218217392538923A5ACB","timestamp":"1471402715"},"msg":"","sucess":true}
                Wechat.sendPaymentRequest(result.data, function () {
                    $ionicPopup.alert({
                        title: "支付结果",
                        template: '支付结果：成功',
                        okText: '确定', // String (默认: 'OK')。OK按钮的文字。
                        okType: 'button-energized' // String (默认: 'button-positive')。OK按钮的类型。
                    });
                }, function (reason) {
                    $ionicPopup.alert({
                        title: "支付结果",
                        template: '支付结果：失败',
                        okText: '确定', // String (默认: 'OK')。OK按钮的文字。
                        okType: 'button-energized' // String (默认: 'button-positive')。OK按钮的类型。
                    });
                });
            }
        }, function (error) {
            console.log(error)
        });
    }

}).controller('UserSchoolCtrl', function ($scope, Util, WelcomeSrv) {

    $scope.user = {};
  
    Util.ajax.get("/api/userInfo", {}).then(function (result) {
        if (result.message == "success") {
            //FIXME:这里应该是result.data扩展$scope.user对象
            $scope.user = result.data;
            $scope.$watch('user.cityCode', function (newValue, oldValue, scope) {
                $scope.getAreas(newValue);
                if (oldValue != newValue) {
                    $scope.user.schoolCode = "";
                    $scope.user.schoolName = "";
                }
            });
        }
    });

    $scope.cities = [];

    $scope.schoolTip = "";

    WelcomeSrv.getRegAreas().then(function (result) {
        if (result.message == "success") {
            var regAreas = result.data;
            for (var aa in regAreas) {
                $scope.cities.push({"code": regAreas[aa].areacode, "name": regAreas[aa].areaname});
            }
        }
    });


    $scope.areas = [];

    $scope.getAreas = function (cityCode) {
        WelcomeSrv.getAreas(cityCode).then(
            function (result) {
                if (result.message == "success") {
                    $scope.areas = result.data;
                    if (result.data.size > 0) {
                        $scope.user.areaCode = result.data[0].areacode;
                    }
                }
            }
        );
    };

    $scope.schools = [];

    $scope.grades = [
        {id: "1", name: "一年级"}, {id: "2", name: "二年级"}, {id: "3", name: "三年级"},
        {id: "4", name: "四年级"}, {id: "5", name: "五年级"}, {id: "6", name: "六年级"}
    ];

    $scope.classes = [
        {id: "1", name: "一班"}, {id: "2", name: "二班"}, {id: "3", name: "三班"},
        {id: "4", name: "四班"}, {id: "5", name: "五班"}, {id: "6", name: "六班"},
        {id: "7", name: "七班"}, {id: "8", name: "八班"}, {id: "9", name: "九班"},
        {id: "10", name: "十班"}, {id: "11", name: "十一班"}, {id: "12", name: "十二班"},
        {id: "13", name: "十三班"}, {id: "14", name: "十四班"}, {id: "15", name: "十五班"},
        {id: "16", name: "十六班"}, {id: "17", name: "十七班"}, {id: "18", name: "十八班"},
        {id: "19", name: "十九班"}, {id: "20", name: "二十班"}, {id: "21", name: "二十一班"},
        {id: "22", name: "二十二班"}, {id: "23", name: "二十三班"}, {id: "24", name: "二十四班"},
        {id: "25", name: "二十五班"}, {id: "26", name: "二十六班"}, {id: "27", name: "二十七班"},
        {id: "28", name: "二十八班"}, {id: "29", name: "二十九班"}, {id: "30", name: "三十班"}
    ];


    $scope.searchSchool = function () {
        var name = $scope.user.schoolName;
        if (name.length == "") {
            $scope.user.schoolCode = "";
            $scope.schools = [];

            $scope.schoolTip = "输入学校名称进行查询!";
        } else {
            WelcomeSrv.searchSchool($scope.user.areaCode, name).then(function (result) {
                if (result.message == "success") {
                    $scope.schools = result.data;

                    if ($scope.schools.length == 0) {
                        $scope.schoolTip = "查不到此学校,请输入学校完整名称！";
                    }
                } else {
                    $scope.schoolTip = "系统查询出错，请联系客服！";
                    $scope.schools = [];
                }
            });
        }
    };

    $scope.changeArea = function () {
        $scope.user.schoolCode = "";
        $scope.user.schoolName = "";
    };

    $scope.selectSchool = function (school) {
        $scope.user.schoolCode = school.schoolcode;
        $scope.user.schoolName = school.schoolname;
        $scope.schools = [];
        $scope.schoolTip = "";
    };

    $scope.goUpdateUser = function () {
        if ($scope.validateUser()) {
            Util.ajax.post("/user/upUserInfo", $scope.user).then(function (result) {
                if (result && result.success) {
                    console.log(result);
                    Util.common.toast("资料已更新！");
                }
            });
        }
    };

    $scope.validateUser = function () {
        var user = $scope.user;

        var userNameV = (user.userName && user.userName.length > 0);
        if (!userNameV) {
            Util.common.toast("请填写您的名字！");
            return false;
        }

        var userCityC = (user.cityCode && user.cityCode.length > 0);
        if (!userCityC) {
            Util.common.toast("请选择您的城市！");
            return false;
        }

        var userAreaC = (user.areaCode && user.areaCode.length > 0);
        if (!userAreaC) {
            Util.common.toast("请选择区域！");
            return false;
        }

        var userSchoolC = (user.schoolCode && user.schoolCode.length > 0);

        if (!userSchoolC) {
            Util.common.toast("请输入您的学校！");
            return false;
        }

        return true;
    }


});