judpAppCrl.controller('WelcomeCtrl', function ($scope, $state, $interval, WelcomeSrv, $ionicPlatform, $ionicLoading,
                                               Util, APP_CONSTANTS, $cordovaAppVersion) {

    $ionicPlatform.ready(function () {
        if (deviceUtil.desktop())
            return;

        /* 版本升级管理  */
        $cordovaAppVersion.getVersionNumber().then(function (version) {
            Util.versionHelper.checkAppUpdate(version);
            APP_CONSTANTS.Version = version;
        });
    });

    $scope.regUser = WelcomeSrv.getRegUser();

    $scope.cities = [];

    $scope.areas = [];

    $scope.resetPwd = {
        mobile: "",
        smsCode: "",
        smsCodeText: "验证码",
        password: "",
        rePassword: ""
    };

    $scope.schoolTip = "输入学校名称进行查询!";
    
    WelcomeSrv.getRegAreas().then(function (result) {
        if (result.message == "success") {
            var regAreas = result.data;
            for (var aa in regAreas) {
                $scope.cities.push({"code": regAreas[aa].areacode, "name": regAreas[aa].areaname});
            }
            if (!$scope.regUser.cityCode)
                $scope.regUser.cityCode = '440100';
        }
    });

    $scope.$watch('regUser.cityCode', function (newValue, oldValue, scope) {
        if (newValue)
            $scope.getAreas(newValue);
    });

    $scope.$watch('regUser.areaCode', function (newValue, oldValue, scope) {
        if ("" == newValue || (oldValue != newValue)) {
            $scope.regUser.schoolCode = "";
            $scope.regUser.schoolName = "";
        }
    });


    $scope.getAreas = function (cityCode) {
        WelcomeSrv.getAreas(cityCode).then( //$scope.regUser.cityCode
            function (result) {
                if (result.message == "success") {
                    $scope.areas = result.data;
                    if (result.data.size > 0) {
                        $scope.regUser.areaCode = result.data[0].areacode;
                    }
                }
            }
        );
    };

    $scope.schools = [];

    $scope.grades = [
        {id: "1", name: "一年级"}, {id: "2", name: "二年级"}, {id: "3", name: "三年级"},
        {id: "4", name: "四年级"}, {id: "5", name: "五年级"}, {id: "6", name: "六年级"}
    ];

    $scope.classes = [
        {id: "1", name: "一班"}, {id: "2", name: "二班"}, {id: "3", name: "三班"},
        {id: "4", name: "四班"}, {id: "5", name: "五班"}, {id: "6", name: "六班"},
        {id: "7", name: "七班"}, {id: "8", name: "八班"}, {id: "9", name: "九班"},
        {id: "10", name: "十班"}, {id: "11", name: "十一班"}, {id: "12", name: "十二班"},
        {id: "13", name: "十三班"}, {id: "14", name: "十四班"}, {id: "15", name: "十五班"},
        {id: "16", name: "十六班"}, {id: "17", name: "十七班"}, {id: "18", name: "十八班"},
        {id: "19", name: "十九"}, {id: "20", name: "二十班"}, {id: "21", name: "二十一班"},
        {id: "22", name: "二十二班"}, {id: "23", name: "二十三班"}, {id: "24", name: "二十四班"},
        {id: "25", name: "二十五班"}, {id: "26", name: "二十六班"}, {id: "27", name: "二十七班"},
        {id: "28", name: "二十八班"}, {id: "29", name: "二十九班"}, {id: "30", name: "三十班"}
    ];

    $scope.options = {
        loop: true,
        effect: 'slide',
        speed: 500,
        autoplay: 2000
    };

    $scope.register = function () {
        $state.go("registerName");
    };

    $scope.goLogin = function () {
        $state.go("login");
    };

    $scope.goRegisterPwd = function () {
        WelcomeSrv.checkSmsCode($scope.regUser.mobile, $scope.regUser.smsCode).then(function (data) {
            if (!data.success) {
                Util.common.toast("验证码不正确！");
                return false;
            } else {
                $state.go("registerPwd");
            }
        });
    };

    $scope.goRegisterMobile = function () {
        console.debug($scope.regUser);
        $state.go("registerMobile");
    };

    $scope.goRegisterPolicy = function () {
        $state.go("registerPolicy");
    };

    $scope.goRegisterPrivate = function () {
        $state.go("registerPrivate");
    };

    $scope.goRegisterArea = function () {
        $state.go("registerArea");
    };

    $scope.goFinish = function () {
        $ionicLoading.show({
            template: "正在注册"
        });

        WelcomeSrv.regUser().then(function (data) {
            if (data.success) {
                Util.common.toast("注册成功！");
                $state.go("login");
            } else {
                Util.common.toast("注册失败！");
            }
        });
    };

    /**
     * 注册界面短信发送
     */
    $scope.smsCode = function () {
        var mobile = $scope.regUser.mobile;
        if (mobile.length != 11) {
            $scope.regUser.mobileValid = false;
            $scope.regUser.msg = "手机号码不正确!";
        } else {
            var seconds = 60;

            var interval = $interval(function () {
                if (seconds == 0) {
                    $interval.cancel(interval);
                    interval = null;

                    $scope.regUser.smsCodeText = "验证码";
                } else {
                    seconds--;
                    $scope.regUser.smsCodeText = "(" + seconds + ")";
                }
            }, 1000);

            //获取短信验证码
            WelcomeSrv.smsCode(mobile).then(
                function (result) {
                    if (result.success) {
                        $scope.regUser.msg = "";
                        $scope.regUser.mobileValid = true;
                    } else {
                        $scope.regUser.msg = result.message;
                    }
                },
                function () {
                    $scope.regUser.msg = "获取短信验证码失败!";
                }
            );
        }
    };

    /**
     * 重置密码的短信发送
     */
    $scope.resetSmsCode = function () {
        var mobile = $scope.resetPwd.mobile;
        if (mobile.length != 11) {
            Util.common.toast("手机号码不正确！");
        } else {
            var seconds = 60;
            var interval = $interval(function () {
                if (seconds == 0) {
                    $interval.cancel(interval);
                    interval = null;

                    $scope.resetPwd.smsCodeText = "验证码";
                } else {
                    seconds--;
                    $scope.resetPwd.smsCodeText = "(" + seconds + ")";
                }
            }, 1000);

            //获取短信验证码
            WelcomeSrv.resetSmsCode(mobile).then(
                function (result) {
                    if (result.success) {
                        Util.common.toast("发送验证码成功！");
                    } else {
                        Util.common.toast(result.message);
                    }
                },
                function () {
                    Util.common.toast("获取验证码失败！");
                }
            );
        }
    };

    $scope.resetPassword = function () {
        $ionicLoading.show({
            template: "正在重置密码"
        });

        WelcomeSrv.resetPassword($scope.resetPwd.mobile, $scope.resetPwd.password, $scope.resetPwd.smsCode).then(
            function (result) {
                console.debug(result);
                if (result.success) {
                    Util.common.toast("重置密码成功！");
                    $state.go("login");
                } else {
                    Util.common.toast(result.message);
                }
            },
            function () {
                Util.common.toast("重置密码失败！");
            }
        );
    };

    $scope.validateResetPwd = function () {
        var resetPwd = $scope.resetPwd;
        validate = (resetPwd.mobile.length == 11 && (resetPwd.password.length > 0 && resetPwd.password == resetPwd.rePassword) && resetPwd.smsCode.length > 0);
        return !validate;
    };

    $scope.searchSchool = function () {
        var name = $scope.regUser.schoolName;
        if (name.length == "") {
            $scope.regUser.schoolCode = "";
            $scope.schools = [];
            $scope.schoolTip = "输入学校名称进行查询！";
        } else {
            WelcomeSrv.searchSchool($scope.regUser.areaCode, name).then(function (result) {
                console.log(result);
                if (result.message == "success") {
                    $scope.schoolTip = "";
                    $scope.schools = result.data;
                    if ($scope.schools.length == 0) {
                        $scope.schoolTip = "查不到此学校,请输入学校完整名称！";
                    }
                } else {
                    $scope.schoolTip = "系统查询出错，请联系客服！";
                    $scope.schools = [];
                }
            });
        }
    };

    $scope.selectSchool = function (school) {
        $scope.regUser.schoolCode = school.schoolcode;
        $scope.regUser.schoolName = school.schoolname;
        $scope.schoolTip = "";
        $scope.schools = [];
    }

});