var judpApp = angular.module('judpapp', ['ionic',  'judpapp.controllers', 'ngResource',
  'judpapp.services', 'judpapp.directives', 'ngCordova']);

var judpAppCrl = angular.module('judpapp.controllers', []);
var judpAppServ = angular.module('judpapp.services', []);
var judpAppDirectives = angular.module('judpapp.directives', []);

judpApp.run(function ($ionicPlatform,  $rootScope, $state, $filter, $stateParams, $cordovaStatusbar, Util) {
    $ionicPlatform.ready(function () {
        if(window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          cordova.plugins.Keyboard.disableScroll(true);
        }
        if(window.StatusBar) {
             $cordovaStatusbar.hide();
        }

        /*推送消息处理*/
        var receivePush = function(event){
            var alertMsg;
            var extras;

            if (window.plugins.jPushPlugin.isPlatformIOS()) {
              alertMsg = event.aps.alert;
              extras = event;
            }else{
              var receiveObj = window.plugins.jPushPlugin.receiveNotification;
              var extras = (receiveObj.extras || [])["cn.jpush.android.EXTRA"];
              alertMsg = receiveObj.alert;
            }
            navigator.notification.confirm(alertMsg, function (result) {
              if (result == 1){

              }
            }, "收到新的信息,是否查看?", ["查看", "取消"]);
        };
        Util.jpush.init(receivePush, receivePush);
        
      }).then(function () {
        if (navigator.splashscreen)
          navigator.splashscreen.hide();
      });

});

judpApp.filter('bookstatusdesc', function () {
    return function (status) {
        switch (status){
            case 0: return "已下架";
                break;
            case 1: return "已上架";
                break;
            default: return "未上架";
        }
    }
})
.filter('borrowstatusdesc', function () {
    return function (status) {
        switch (status){
            case 0: return "申请阶段";
                break;
            case 1: return "同意借出";
                break;
            case 2: return "准备交接";
                break;
            case 3: return "已借出";
                break;
            case 4: return "准备归还交接";
                break;
            case 7: return "取消借阅";
                break;
            case 8: return "不同意借阅";
                break;
            case 9: return "完成借阅";
                break;
            default: return "未知";
        }
    }
});