judpApp.config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider) {

    $stateProvider.state('welcome', {
        url: '/welcome',
        templateUrl: 'app/welcome/welcome.html',
        controller: 'WelcomeCtrl'
    })
        .state('registerName', {
            url: '/registerName',
            templateUrl: 'app/welcome/register_name.html',
            controller: 'WelcomeCtrl'
        })
        .state('registerMobile', {
            url: '/registerMobile',
            templateUrl: 'app/welcome/register_mobile.html',
            controller: 'WelcomeCtrl'
        })
        .state('registerPwd', {
            url: '/registerPwd',
            templateUrl: 'app/welcome/register_pwd.html',
            controller: 'WelcomeCtrl'
        })
        .state('resetPwd', {
            url: '/resetPwd',
            templateUrl: 'app/welcome/reset_pwd.html',
            controller: 'WelcomeCtrl'
        })
        .state('registerArea', {
            url: '/registerArea',
            templateUrl: 'app/welcome/register_area.html',
            controller: 'WelcomeCtrl'
        })
        .state('registerPolicy', {
            url: '/registerPolicy',
            templateUrl: 'app/welcome/register_policy.html',
            controller: 'WelcomeCtrl'
        })
        .state('registerPrivate', {
            url: '/registerPrivate',
            templateUrl: 'app/welcome/register_private.html',
            controller: 'WelcomeCtrl'
        })
        .state('login', {
            url: '/login',
            templateUrl: 'app/login/login.html',
            controller: 'LoginCtrl'

        })
        .state('home', {
            url: '/home',
            abstract: true,
            templateUrl: 'app/home/tabs.html',
            controller: 'HomeCtrl'
        })
        .state('home.shelf', {
            url: '/shelf',
            views: {
                'shelf-view': {
                    templateUrl: 'app/shelf/shelf.html',
                    controller: 'BookShelfCtrl'
                }
            }
        })
        .state('home.bookdetail', {
            url: '/bookdetail',
            views: {
                'shelf-view': {
                    templateUrl: 'app/shelf/bookdetail.html',
                    controller: "MybookDetailCtrl"
                }
            }
        })
        .state('home.borrowdetail', {
            url: '/borrowdetail',
            views: {
                'shelf-view': {
                    templateUrl: 'app/shelf/borrowdetail.html',
                    controller: "BorrowDetailCtrl"
                }
            },
            params: {bookItem: null, type: ''}
        })
        .state('home.bookstore', {
            url: '/bookstore',
            views: {
                'bookstore-view': {
                    templateUrl: 'app/bookstore/bookstore.html',
                    controller: ""
                }
            }
        })
        .state('home.square', {
            url: '/square',
            views: {
                'square-view': {
                    templateUrl: 'app/square/square.html'
                }
            }
        })
        .state('home.userprofile', {
            url: '/userprofile',
            views: {
                'userprofile-view': {
                    templateUrl: 'app/userprofile/userprofile.html',
                    controller: "UserProfileCtrl"
                }
            }
        })
        .state('home.userdetail', {
            url: '/userdetail',
            views: {
                'userprofile-view': {
                    templateUrl: 'app/userprofile/userdetail.html',
                    controller: "UserDetailCtrl"
                }
            }
        })
        .state('home.userschool', {
            url: '/userschool',
            views: {
                'userprofile-view': {
                    templateUrl: 'app/userprofile/userschool.html',
                    controller: "UserSchoolCtrl"
                }
            }
        });

    if (!localStorage.getItem("welcome")) {
        $urlRouterProvider.otherwise('/welcome');
        // localStorage.setItem("welcome", true);
    }
    else
        $urlRouterProvider.otherwise('/login');

    $ionicConfigProvider.views.maxCache(5);
    $ionicConfigProvider.views.forwardCache(false);
    $ionicConfigProvider.backButton.text(false);
    $ionicConfigProvider.backButton.previousTitleText(false);

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('standard');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

}).provider('runtimeStates', function runtimeStates($stateProvider) {
    this.$get = function ($q, $timeout, $state) {
        return {
            addState: function (name, state) {
                $stateProvider.state(name, state);
            }
        }
    }
});
